      subroutine F1F2(diss,x,q2,mx,f1,f2)
      implicit none
      double precision xmod,wcut,r,alphaEM
      double precision q2_mod,sigtlnr,q2_cb0,q2_cb1,q0
      double precision x,q2,mx,f1,f2,fl
      double precision rfit,f2diff,f2c,df2,delq
      logical diss

      include 'mp.f'
      include 'pi.f'
      include 'pdfinf.f'
      
      wcut=dsqrt(3.5d0)
      if(ipdf.eq.57)wcut=dsqrt(3d0)
      if(ipdf.eq.58)wcut=dsqrt(4d0)
      q0=1d0

      wcut=dsqrt(3d0)
      
      if(diss)then
         if(mx.lt.wcut)then
            call f2sf(1,q2,x,f2)

            q2_cb0=8d0
            q2_cb1=30d0
            delq=q2-q2_cb0
            q2_mod=q2_cb0+delq/(1d0+delq/(q2_cb1-q2_cb0))
            xmod=q2_mod/(mx**2-mp**2+q2_mod)
            
            if(q2.lt.q2_cb0)then
               q2_mod=q2
               xmod=x
            endif
            
            f2c=sigtlnr(xmod,q2_mod)/389d0
            f2c=f2c*q2_mod**2*(1d0-xmod)/(q2_mod+4d0*mp**2*xmod**2)
            f2c=f2c/4d0/pi**2/alphaEM(q2_mod)
            if(q2_mod.gt.8d0)f2c=f2c*q2_cb1/(q2_cb1+delq)
            
            f2diff=f2c-f2

            if(mx.lt.mp+0.135d0)f2diff=0d0
            if(f2diff.lt.0d0)f2diff=-f2diff

            if(ipdf.eq.51)f2=f2+f2diff
            if(ipdf.eq.52)f2=f2-f2diff

            if(q2.gt.q0)then
               r=rfit(2,x,q2)
               if(ipdf.eq.53)r=r*0.5d0
               if(ipdf.eq.54)r=r*1.5d0
               f1=f2*(1d0+4d0*mp**2*x**2/q2)/(1d0+r)/2d0/x
            else
               r=rfit(2,x,q0)
               if(ipdf.eq.53)r=r*0.5d0
               if(ipdf.eq.54)r=r*1.5d0
               f1=f2*(1d0+4d0*mp**2*x**2/q0)/(1d0+r)/2d0/x
            endif
            
         else
            if(q2.lt.q0)then
               call gd_fit_11(x,q2,mx**2,f2,df2)
               if(ipdf.eq.55)f2=f2-df2
               if(ipdf.eq.56)f2=f2+df2
               
               r=rfit(2,x,q0)
               if(ipdf.eq.53)r=r*0.5d0
               if(ipdf.eq.54)r=r*1.5d0
               f1=f2*(1d0+4d0*mp**2*x**2/q0)/(1d0+r)/2d0/x
               
            else
               call F1F2ap(x,q2,f2,fl)
               f1=f2-fl
               f1=f1/2d0/x
            endif
         endif
      else
         call F1F2el(q2,f1,f2)         
      endif
      
      if(f1.lt.0d0)f1=0d0
      if(f2.lt.0d0)f2=0d0
      
      return
      end
