      subroutine F1F2ev(x,q2,f1,f2)
      implicit none
      double precision sq,f1,f2,x,q2,phot
      double precision garr(-6:6)

cccccc lo test
      
      call evolvePDFphoton(x,dsqrt(q2),garr,phot)
      
      sq=(garr(2)+garr(-2)+garr(4)+garr(-4))*4d0+garr(1)+
     &     garr(-1)+garr(3)+garr(-3)
      sq=(sq+garr(5)+garr(-5))/9d0

      f2=sq
      f1=f2/2d0/x
      
      return
      end

      subroutine F1F2ev_sq(x,q2,f1,f2)
      implicit none
      double precision sq,f1,f2,x,q2,phot
      double precision garr(-6:6)

cccccc lo test                                                                                         

      call evolvePDFphoton(x,dsqrt(q2),garr,phot)

      sq=(garr(2)+garr(-2)+garr(4)+garr(-4))*16d0+garr(1)+
     &     garr(-1)+garr(3)+garr(-3)
      sq=(sq+garr(5)+garr(-5))/9d0**2

      f2=sq
      f1=f2/2d0/x

      return
      end
      
      subroutine PDFcomb(x,q2,fu,fub,fd,fdb)
      implicit none
      double precision fu,fub,fd,fdb
      double precision x,q2,phot
      double precision garr(-6:6)
      integer i
      
      call evolvePDFphoton(x,dsqrt(q2),garr,phot)
   
      fu=0d0
      fub=0d0
      fd=0d0
      fdb=0d0
      
      do i=2,4,2
         fu=fu+garr(i)
         fub=fub+garr(-i)
      enddo

      do i=1,5,2
         fd=fd+garr(i)
         fdb=fdb+garr(-i)
      enddo

      return
      end
      
      subroutine FNClo_u(x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z)
      implicit none
      double precision x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z
      double precision pz,pz2,phot
      double precision garr(-6:6)
      integer i

      include 'ewsf.f'
      
      call evolvePDFphoton(x,dsqrt(q2),garr,phot)

      ve = - 0.5d0 + 2d0 * Sin2ThetaW
      ae = - 0.5d0
      
      pz=Q2/(Q2+MZ**2) 
     &     /(4d0*Sin2ThetaW*(1d0-Sin2ThetaW))
      pz2=pz*pz
      
      f2gz=0d0
      f2z=0d0
      f3gz=0d0
      f3z=0d0
      do i=2,4,2
         f2gz=f2gz+(garr(i)+garr(-i))*azgam(i)*pz
         f2z=f2z+(garr(i)+garr(-i))*az(i)*pz2
         f3gz=f3gz+(garr(i)-garr(-i))*bzgam(i)*pz
         f3z=f3z+(garr(i)-garr(-i))*bz(i)*pz2
      enddo

      f1gz=f2gz/2d0/x
      f1z=f2z/2d0/x
      
      return
      end
      
      subroutine FNClo_d(x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z)
      implicit none
      double precision x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z
      double precision pz,pz2,phot
      double precision garr(-6:6)
      integer i

      include 'ewsf.f'
      
      call evolvePDFphoton(x,dsqrt(q2),garr,phot)

      ve = - 0.5d0 + 2d0 * Sin2ThetaW
      ae = - 0.5d0
      
      pz=Q2/(Q2+MZ**2) 
     &     /(4d0*Sin2ThetaW*(1d0-Sin2ThetaW))
      pz2=pz*pz
      
      f2gz=0d0
      f2z=0d0
      f3gz=0d0
      f3z=0d0
      do i=1,5,2
         f2gz=f2gz+(garr(i)+garr(-i))*azgam(i)*pz
         f2z=f2z+(garr(i)+garr(-i))*az(i)*pz2
         f3gz=f3gz+(garr(i)-garr(-i))*bzgam(i)*pz
         f3z=f3z+(garr(i)-garr(-i))*bz(i)*pz2
      enddo

      f1gz=f2gz/2d0/x
      f1z=f2z/2d0/x
      
      return
      end
      
      subroutine FNClo(x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z)
      implicit none
      double precision x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z
      double precision pz,pz2,phot
      double precision garr(-6:6)
      integer i

      include 'ewsf.f'
      
      call evolvePDFphoton(x,dsqrt(q2),garr,phot)

      ve = - 0.5d0 + 2d0 * Sin2ThetaW
      ae = - 0.5d0
      
      pz=Q2/(Q2+MZ**2) 
     &     /(4d0*Sin2ThetaW*(1d0-Sin2ThetaW))
      pz2=pz*pz

      f2gz=0d0
      f2z=0d0
      f3gz=0d0
      f3z=0d0
      do i=1,5
         f2gz=f2gz+(garr(i)+garr(-i))*azgam(i)*pz
         f2z=f2z+(garr(i)+garr(-i))*az(i)*pz2
         f3gz=f3gz+(garr(i)-garr(-i))*bzgam(i)*pz
         f3z=f3z+(garr(i)-garr(-i))*bz(i)*pz2
      enddo

      f1gz=f2gz/2d0/x
      f1z=f2z/2d0/x
      
      return
      end

      subroutine FNC(x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z)
      implicit none
      double precision x,q2,f1gz,f1z,f2gz,f2z,f3gz,f3z
      double precision pz,pz2
      double precision flgz,flz

      include 'pdfinf.f'
      include 'ewsf.f'

      pz=Q2/(Q2+MZ**2) 
     &     /(4d0*Sin2ThetaW*(1d0-Sin2ThetaW))
      pz2=pz*pz

      if(SCerror)then
         call lhapdf_xfxq2(2,0,902,x,q2,f2gz)
         call lhapdf_xfxq2(2,0,903,x,q2,flgz)
         call lhapdf_xfxq2(2,0,904,x,q2,f3gz)
         f2gz=f2gz*pz
         flgz=flgz*pz
         f3gz=f3gz*pz
         f1gz=(f2gz-flgz)/2d0/x
         call lhapdf_xfxq2(2,0,905,x,q2,f2z)
         call lhapdf_xfxq2(2,0,906,x,q2,flz)
         call lhapdf_xfxq2(2,0,907,x,q2,f3z)
         f2z=f2z*pz2
         flz=flz*pz2
         f3z=f3z*pz2
         f1z=(f2z-flz)/2d0/x
      elseif(ipdf.le.50)then
         call lhapdf_xfxq2(2,ipdf,902,x,q2,f2gz)
         call lhapdf_xfxq2(2,ipdf,903,x,q2,flgz)
         call lhapdf_xfxq2(2,ipdf,904,x,q2,f3gz)
         f2gz=f2gz*pz
         flgz=flgz*pz
         f3gz=f3gz*pz
         f1gz=(f2gz-flgz)/2d0/x
         call lhapdf_xfxq2(2,ipdf,905,x,q2,f2z)
         call lhapdf_xfxq2(2,ipdf,906,x,q2,flz)
         call lhapdf_xfxq2(2,ipdf,907,x,q2,f3z)
         f2z=f2z*pz2
         flz=flz*pz2
         f3z=f3z*pz2
         f1z=(f2z-flz)/2d0/x
      else
         call lhapdf_xfxq2(2,0,902,x,q2,f2gz)
         call lhapdf_xfxq2(2,0,903,x,q2,flgz)
         call lhapdf_xfxq2(2,0,904,x,q2,f3gz)
         f2gz=f2gz*pz
         flgz=flgz*pz
         f3gz=f3gz*pz
         f1gz=(f2gz-flgz)/2d0/x
         call lhapdf_xfxq2(2,0,905,x,q2,f2z)
         call lhapdf_xfxq2(2,0,906,x,q2,flz)
         call lhapdf_xfxq2(2,0,907,x,q2,f3z)
         f2z=f2z*pz2
         flz=flz*pz2
         f3z=f3z*pz2
         f1z=(f2z-flz)/2d0/x
      endif
      
      return
      end
      
      subroutine F1F2ap(x,q2,f2,fl)
      implicit double precision(a-y)
      integer ie,i
      double precision garr(-6:6)

      include 'pdfinf.f'

      if(SCerror)then
         call lhapdf_xfxq2(2,0,900,x,q2,f2)
         call lhapdf_xfxq2(2,0,901,x,q2,fl)
      elseif(ipdf.le.50)then
         call lhapdf_xfxq2(2,ipdf,900,x,q2,f2)
         call lhapdf_xfxq2(2,ipdf,901,x,q2,fl)
      else
         call lhapdf_xfxq2(2,0,900,x,q2,f2)
         call lhapdf_xfxq2(2,0,901,x,q2,fl)
      endif

      return
      end
