      subroutine ll_coll(p)
      implicit none
      double precision alphaEM,ul,tl
      complex*16 zt1,zt2,zout1,zout2,zout
      double precision q1(4),q2(4),ppos(4)
      complex*16 uelb(4),vpos(4)
      integer i1,i2
      integer i,j,k,l,p,m,n
      
      include 'mom.f'
      include 'gmatrices.f'
      include 'gmatrices_comb.f'
      include 'ewpars.f'
      include 'pi.f'
      include 'vars.f'
      include 'partonmom2.f'
      include 'norm.f'
      include 'mq.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'diss.f'
      include 'x.f'
      include 'kmu.f'

      do i=1,2
         q1(i)=0d0
         q2(i)=0d0
      enddo
      
      q1(4)=x1*rts/2d0
      q1(3)=q1(4)
      q2(4)=x2*rts/2d0
      q2(3)=-q2(4)
      
      do i=1,4        
         ppos(i)=q(i,7)
      enddo

      
      if(p.eq.1)then            ! ++
         call upb(6,uelb)
         call vp(7,vpos)
      elseif(p.eq.2)then        ! --
         call umb(6,uelb)
         call vm(7,vpos)
      elseif(p.eq.3)then        ! +-
         call umb(6,uelb)
         call vp(7,vpos)
      elseif(p.eq.4)then        ! -+
         call upb(6,uelb)
         call vm(7,vpos)
      endif
      
      ul=(q1(4)-ppos(4))**2-(q1(3)-ppos(3))**2
     &     -(q1(2)-ppos(2))**2-(q1(1)-ppos(1))**2
      tl=(q2(4)-ppos(4))**2-(q2(3)-ppos(3))**2
     &     -(q2(2)-ppos(2))**2-(q2(1)-ppos(1))**2
      
      do i1=1,4
         do i2=1,4

            zout1=0d0
            zout2=0d0
            
      do 900 i=1,4
      do 900 l=1,4
            
         do j=1,4

            zt1=uelb(i)*gmatrix_3(i2,j,i1,i,l)*
     &           vpos(l)*(q1(j)-ppos(j))
            if(j.lt.4)zt1=-zt1
            zt2=uelb(i)*gmatrix_3(i1,j,i2,i,l)*
     &           vpos(l)*(q2(j)-ppos(j))
            if(j.lt.4)zt2=-zt2
            
            zout1=zout1+zt1
            zout2=zout2+zt2

         enddo

 900  enddo

      zout1=zout1/ul
      zout2=zout2/tl

      zout=zout1+zout2
      zout=zout*4d0*pi*alphaEM(kmu**2*mx**2)   
      zout=zout*dsqrt(conv)
      zoutarr(p,i1,i2)=zout
  
      enddo
      enddo
      
      return
      end
