cc   gamma gamma --> l+l- subprocess amplitude - off-shell, massless leptons (for simplicity/speed)
      subroutine lloff(p)
      implicit none
      complex*16 zt1,zt2,zout1,zout2,zout,zt
      double precision alphaem,ul,tl
      double precision ppos(4)
      complex*16 uelb(4),vpos(4),zoutq1(4,4),zoutp(4,4),zoutq2(4,4)
      complex*16 wpm(4),wpm_5(4),wpm_5e(4,4,4)
      integer i1,i2
      integer i,j,k,l,p,m,n
      
      include 'mom.f'
      include 'gmatrices.f'
      include 'gmatrices_comb.f'
      include 'ewpars.f'
      include 'pi.f'
      include 'vars.f'
      include 'partonmom2.f'
      include 'norm.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'diss.f'
      include 'x.f'
      include 'qsq.f'
      
      do i=1,4
         ppos(i)=q(i,7)
      enddo

      if(p.eq.1)then            ! ++   gam_5 v = -
         call upb(6,uelb)
         call vp(7,vpos)
      elseif(p.eq.2)then        ! --   gam_5 v = +
         call umb(6,uelb)
         call vm(7,vpos)
      elseif(p.eq.3)then        ! +-   gam_5 v = -
         call umb(6,uelb)
         call vp(7,vpos)
      elseif(p.eq.4)then        ! -+  gam_5 v = +
         call upb(6,uelb)
         call vm(7,vpos)
      endif

      ul=(q1(4)-ppos(4))**2-(q1(3)-ppos(3))**2
     &     -(q1(2)-ppos(2))**2-(q1(1)-ppos(1))**2
      tl=(q2(4)-ppos(4))**2-(q2(3)-ppos(3))**2
     &     -(q2(2)-ppos(2))**2-(q2(1)-ppos(1))**2
      
      do j=1,4
         wpm(j)=0d0
         wpm_5(j)=0d0
         do i1=1,4
            do i2=1,4
               wpm(j)=wpm(j)+uelb(i1)*gmatrix(j,i1,i2)*vpos(i2)
               wpm_5(j)=wpm_5(j)+uelb(i1)*gmatrix5_1(j,i1,i2)*vpos(i2)
            enddo
         enddo
         zsing(p,j)=wpm(j)*4d0*pi*alphaEM(mx**2)*dsqrt(conv)
      enddo

      do i=1,4
         do j=1,4
            do k=1,4
               wpm_5e(i,j,k)=0d0
               do i1=1,4
                  do i2=1,4
                     zt=uelb(i1)*epgam(i,j,k,i1,i2)*vpos(i2)
                     wpm_5e(i,j,k)=wpm_5e(i,j,k)+zt
                  enddo
               enddo
            enddo
         enddo
      enddo
      
      do i1=1,4
         do i2=1,4

            zout1=0d0
            zout2=0d0
            
      do 900 i=1,4
      do 900 l=1,4
            
         do j=1,4

            zt1=uelb(i)*gmatrix_3(i2,j,i1,i,l)*
     &           vpos(l)*(q1(j)-ppos(j))
            if(j.lt.4)zt1=-zt1
            zt2=uelb(i)*gmatrix_3(i1,j,i2,i,l)*
     &           vpos(l)*(q2(j)-ppos(j))
            if(j.lt.4)zt2=-zt2
            
            zout1=zout1+zt1
            zout2=zout2+zt2

         enddo

 900  enddo


      zout1=zout1/ul
      zout2=zout2/tl

      zout=zout1+zout2
      zout=zout*4d0*pi*dsqrt(alphaEM(qsq1)*alphaEM(qsq2))
      zout=zout*dsqrt(conv)

      zoutarr(p,i1,i2)=zout
      
  
      enddo
      enddo
      
      return
      end
