ccccc EPA form factors (proton)
      subroutine SFcalc(p,out)
      implicit none
      complex*16 zt,zoutz,zoutsf
      complex*16 ztsf,zt_zz,zt_zg
      complex*16 zt_zz1_zz2,zt_zz1_zg2,zt_zz1_g2,zt_zg1_zz2
     &     ,zt_zg1_zg2,zt_zg1_g2,zt_g1_zz2,zt_g1_zg2
      double precision xi1,xi2,x1t,x2t,x1tt,x2tt
      double precision sf_g
      complex*16 sf_zg,sf_z
      double precision ptll,mtll
      double precision alphaEM
      double precision outzz1,outzz2,outzg1,outzg2,outgg1,outgg2,outn
      double precision cs_sf,cs_nsf1,cs_nsf2
      double precision beta
      double precision out    
      double precision p1(4),p2(4)
      double precision pq1(4),pq2(4)
      integer p,i,j,k,l,mu,mup,nu,nup,i1,j1,k1,k2
      double precision sf1(4,4),sf2(4,4),nsf1(4,4,3),nsf2(4,4,3)
      complex*16 ansf1(4,2,2,8),ansf2(4,2,2,8)
      complex*16 znsfarr1(10),znsfarr2(10)
      double precision sf1_g(4,4),sf2_g(4,4)
      double precision f1ar(4),f2ar(4)
      complex*16 sf1_Z(4,4),sf2_Z(4,4),sf1_Zg(4,4),sf2_Zg(4,4)
      common/sffull/sf1_g,sf2_g
      common/sfz/sf1_z,sf2_z
      common/sfzg/sf1_zg,sf2_zg
      
      include 'mp.f'
      include 'pi.f'
      include 'x.f'
      include 'xb.f'
      include 'diss.f'
      include 'vars.f'
      include 'mom.f'
      include 'ewpars.f'
      include 'proc.f'
      include 'norm.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'gmatrices.f'
      include 'NSF.f'
      include 'ewsf.f'
      include 'zinit.f'
      include 'kmu.f'
      include 'qsq.f'
      
      do i=1,4
         p1(i)=q(i,1)
         p2(i)=q(i,2)
      enddo

      xi1=-qsq1/rts/(q1(4)-q1(3))
      xi2=-qsq2/rts/(q2(4)+q2(3))

cccccccccccccc      
      
      pq1(4)=rts/2d0*xi1
      pq1(3)=pq1(4)
      pq2(4)=rts/2d0*xi2
      pq2(3)=-pq2(4)

cccccccccccccccccc      
      
      beta=q(3,1)/q(4,1)

      x1t=(q1(4)+q1(3)/beta)/rts
      x1tt=(q1(4)-q1(3)/beta)/rts
      x2t=(q2(4)-q2(3)/beta)/rts
      x2tt=(q2(4)+q2(3)/beta)/rts

cccccccccccccccc      

      ptll=dsqrt((q(1,6)+q(1,7))**2+(q(2,6)+q(2,7))**2)
      mtll=dsqrt(mx**2+ptll**2)
    
ccccccccccc

      if(NSF.eqv..false.)goto 888

ccccc Mixed contribution
      
      do i1=1,2
         do j1=1,2
            do mu=1,4
               call vertexNSFamp(p,mu,i1,j1,pq1,q1,q2,znsfarr1) ! arr1(1,5) = u, 2,6 = ubar, 3,7 = d, 4,8 = dbar
               call vertexNSFamp(p,mu,i1,j1,pq2,q2,q1,znsfarr2)
               
               do i=1,4
                  if(diss1.eqv..false..or.qsq1.lt.1d0)znsfarr1(i)=0d0
                  if(diss2.eqv..false..or.qsq2.lt.1d0)znsfarr2(i)=0d0  
                  ansf1(mu,i1,j1,i)=znsfarr1(i)
                  ansf2(mu,i1,j1,i)=znsfarr2(i)
               enddo

               do i=5,8
                  if(diss1.eqv..false..or.qsq1.lt.1d0)znsfarr1(i)=0d0
                  if(diss2.eqv..false..or.qsq2.lt.1d0)znsfarr2(i)=0d0
                  ansf1(mu,i1,j1,i)=znsfarr1(i)
                  ansf2(mu,i1,j1,i)=znsfarr2(i)
               enddo
               
            enddo
         enddo
      enddo

      call PDFcomb(xi1,mtll**2*kmu**2,f1ar(1),f1ar(2),f1ar(3),f1ar(4))
      call PDFcomb(xi2,mtll**2*kmu**2,f2ar(1),f2ar(2),f2ar(3),f2ar(4))
      
      do mu=1,4
         do mup=1,4
            outgg1=0d0
            outzg1=0d0
            outzz1=0d0
            outgg2=0d0
            outzg2=0d0
            outzz2=0d0
            do i=1,2
               do j=1,2
                  do k=1,4
                     outgg1=outgg1+ansf1(mu,i,j,k)*
     &                    conjg(ansf1(mup,i,j,k))*f1ar(k)/xi1
                     outgg2=outgg2+ansf2(mu,i,j,k)*
     &                    conjg(ansf2(mup,i,j,k))*f2ar(k)/xi2

                     if(zinit)then
                        outzz1=outzz1+ansf1(mu,i,j,k+4)*
     &                       conjg(ansf1(mup,i,j,k+4))*f1ar(k)/xi1
                        outzz2=outzz2+ansf2(mu,i,j,k+4)*
     &                       conjg(ansf2(mup,i,j,k+4))*f2ar(k)/xi2
                        
                        outzg1=outzg1+2d0*dreal(ansf1(mu,i,j,k)*
     &                       conjg(ansf1(mup,i,j,k+4)))*f1ar(k)/xi1
                        outzg2=outzg2+2d0*dreal(ansf2(mu,i,j,k)*
     &                       conjg(ansf2(mup,i,j,k+4)))*f2ar(k)/xi2
                     endif
                  
                  enddo
               enddo
            enddo
            nsf1(mu,mup,1)=outgg1/mx**2/2d0   ! gam gam
            nsf2(mu,mup,1)=outgg2/mx**2/2d0
            if(zinit)then
               nsf1(mu,mup,2)=outzg1/mx**2/2d0 ! Z gam interf.
               nsf2(mu,mup,2)=outzg2/mx**2/2d0
               nsf1(mu,mup,3)=outzz1/mx**2/2d0 ! ZZ
               nsf2(mu,mup,3)=outzz2/mx**2/2d0
            endif
            
         enddo
      enddo

 888  continue
    
      if(p.eq.1)then  ! gam-gam density matrices
      do mu=1,4
         do mup=1,4
            sf1_g(mu,mup)=SF_g(diss1,mu,mup,xb1,x1t,x1tt,p1,q1,mx)
            sf2_g(mu,mup)=SF_g(diss2,mu,mup,xb2,x2t,x2tt,p2,q2,mx)
         enddo
      enddo


      if(zinit)then
         if(p.eq.1)then ! gam-Z and Z-Z density matrices
         do mu=1,4
            do mup=1,4
               sf1_Z(mu,mup)=SF_Z(diss1,mu,mup,xb1,x1t,x1tt,p1,q1,mx)
               sf2_Z(mu,mup)=SF_Z(diss2,mu,mup,xb2,x2t,x2tt,p2,q2,mx)
               sf1_Zg(mu,mup)=SF_Zg(diss1,mu,mup,xb1,x1t,x1tt,p1,q1,mx)
               sf2_Zg(mu,mup)=SF_Zg(diss2,mu,mup,xb2,x2t,x2tt,p2,q2,mx)
            enddo
         enddo
         endif
      endif
      
      endif
      
      if(noSF)then
         cs_SF=0d0
         goto 889
      endif
    
      zoutsf=0d0
      zoutz=0d0

ccccc  SF contribution      
      
      do mu=1,4
         do mup=1,4
            do nu=1,4
               do nup=1,4
    
                  zt=zoutarr(p,mu,nu)*dconjg(zoutarr(p,mup,nup))
                  
                  if(mu.lt.4)zt=-zt
                  if(mup.lt.4)zt=-zt
                  if(nu.lt.4)zt=-zt
                  if(nup.lt.4)zt=-zt

                  ztsf=zt*sf1_g(mu,mup)*sf2_g(nu,nup)
                  zoutsf=zoutsf+ztsf

                  if(zinit)then
                     
                     zt_zz1_zz2=zt*sf1_Z(mu,mup)*sf2_Z(nu,nup)*
     &                    (ve**2+ae**2-2d0*ae*ve*llsign(p))**2
                     zt_zz1_g2=zt*sf1_Z(mu,mup)*sf2_g(nu,nup)*
     &                    (ve-ae*llsign(p))**2
                     zt_g1_zz2=zt*sf1_g(mu,mup)*sf2_Z(nu,nup)*
     &                    (ve-ae*llsign(p))**2
                     zt_zg1_g2=zt*sf1_Zg(mu,mup)*sf2_g(nu,nup)*
     &                    (ve-ae*llsign(p))
                     zt_g1_zg2=zt*sf1_g(mu,mup)*sf2_Zg(nu,nup)*
     &                    (ve-ae*llsign(p))
                     zt_zz1_zg2=zt*sf1_Z(mu,mup)*sf2_Zg(nu,nup)*
     &                    (ve**2+ae**2-2d0*ae*ve*llsign(p))*
     &                    (ve-ae*llsign(p))
                     zt_zg1_zz2=zt*sf1_Zg(mu,mup)*sf2_Z(nu,nup)*
     &                    (ve**2+ae**2-2d0*ae*ve*llsign(p))*
     &                    (ve-ae*llsign(p))
                     zt_zg1_zg2=zt*sf1_Zg(mu,mup)*sf2_Zg(nu,nup)*
     &                    (ve-ae*llsign(p))**2
                     
                     zoutz=zoutz+zt_zz1_zz2
                     zoutz=zoutz+zt_zz1_zg2+zt_zg1_zz2
                     zoutz=zoutz+zt_g1_zz2+zt_zz1_g2+zt_zg1_zg2
                     zoutz=zoutz+zt_g1_zg2+zt_zg1_g2                    
                     
                  endif

               enddo
            enddo
         enddo
      enddo
      
      if(zinit)zoutsf=zoutsf+zoutz
      
      outn=dreal(zoutsf)
      outn=outn*(alphaEM(qsq1)*alphaEM(qsq2)/qsq1/qsq2)
      
      if(outn.lt.0d0)outn=0d0
    
      cs_SF=outn

      if(NSF.eqv..false.)then
         out=cs_SF
         return
      endif
         
cccccccc

 889  zoutsf=0d0

      zoutz=0d0
      
      do mu=1,4
         do mup=1,4

            nu=mu
            nup=mup
            zt=d_(mu,nu)*d_(mup,nup)  
                           
            
            ztsf=zt*nsf1(mu,mup,1)*sf2_g(nu,nup)
            zoutsf=zoutsf+ztsf
                  
            if(zinit)then
               zt_zg=zt*nsf1(mu,mup,2)*sf2_Zg(nu,nup)
               zt_zz=zt*nsf1(mu,mup,3)*sf2_Z(nu,nup)
               zoutz=zoutz+zt_zg+zt_zz                     
            endif
                        
         enddo
      enddo

      outn=dreal(zoutsf)
      if(zinit)outn=outn+dreal(zoutz)
      outn=outn*(alphaEM(qsq2)**2/qsq2/mx**2)
      
      cs_NSF1=outn

cccccccc      

      zoutsf=0d0
      zoutz=0d0
      
      do mu=1,4
         do mup=1,4
            nu=mu
            nup=mup
            zt=d_(mu,nu)*d_(mup,nup)
            
            ztsf=zt*nsf2(mu,mup,1)*sf1_g(nu,nup)
            zoutsf=zoutsf+ztsf
                  
            if(zinit)then
               zt_zg=zt*nsf2(mu,mup,2)*sf1_Zg(nu,nup)
               zt_zz=zt*nsf2(mu,mup,3)*sf1_Z(nu,nup)
               zoutz=zoutz+zt_zg+zt_zz                     
            endif
            
         enddo
      enddo

      outn=dreal(zoutsf)
      if(zinit)outn=outn+dreal(zoutz)
      outn=outn*(alphaEM(qsq1)**2/qsq1/mx**2)

      cs_NSF2=outn

cccccccccc
      
      out=cs_SF+cs_NSF1+cs_NSF2
      
      return
      end


      subroutine vertexNSFamp(p,mu,h1,h2,pq1,q1,q2,zarr)
      implicit none
      complex*16 zt1,zt2,zout,zout1,zout2
      double precision sign,qsq2,mx,pzp
      double precision q2_pq1,pq1_pxc
      double precision pq1(4),q1(4),q2(4)
      double precision pq1c(4),q2c(4),pxc(4)
      complex*16 u(4),ub(4)
      integer h1,h2,i,j,i1,i2,i3,mu,sig,p
      complex*16 zarr(10)
           
      include 'gmatrices.f'
      include 'gmatrices_comb.f'
      include 'mom.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'ewsf.f'
      include 'zinit.f'

      pzp=1d0/(4d0*Sin2ThetaW*(1d0-Sin2ThetaW))
      
      do i=1,3
         pq1c(i)=-pq1(i)
         q2c(i)=-q2(i)
         pxc(i)=-q(i,5)
      enddo
      pq1c(4)=pq1(4)
      q2c(4)=q2(4)
      pxc(4)=q(4,5)

      mx=dsqrt(q(4,5)**2-q(3,5)**2-q(2,5)**2-q(1,5)**2)

      do i=1,4
         q(i,16)=pq1(i)
         q(i,17)=pq1(i)-q1(i)
      enddo

      if(h1.eq.1.and.h2.eq.1)then ! g5 u = +
         call up(16,u)
         call upb(17,ub)
         sign=1d0
      elseif(h1.eq.1.and.h2.eq.2)then ! g5 u = +
         call up(16,u)
         call umb(17,ub)
         sign=1d0
      elseif(h1.eq.2.and.h2.eq.1)then ! g5 u = -
         call um(16,u)
         call upb(17,ub)
         sign=-1d0
      else                          ! g5 u = -
         call um(16,u)
         call umb(17,ub)
         sign=-1d0
      endif

      zout=0d0
      zout1=0d0
      zout2=0d0
      
      do i1=1,4
         do i2=1,4
            do sig=1,4
               do j=1,4
                  zt1=ub(i1)*gmatrix_3(sig,j,mu,i1,i2)*u(i2)*
     &                 (pq1c(j)+q2c(j))
                  zt2=ub(i1)*gmatrix_3(mu,j,sig,i1,i2)*u(i2)*
     &                 (pq1c(j)-pxc(j))
                  if(sig.lt.4)zt1=-zt1
                  if(sig.lt.4)zt2=-zt2
                     zout1=zout1+zt1*zsing(p,sig)
                     zout2=zout2+zt2*zsing(p,sig)
                  enddo
            enddo
         enddo
      enddo

      qsq2=q2(4)**2-q2(3)**2-q2(2)**2-q2(1)**2
      qsq2=-qsq2
 
      q2_pq1=q2(4)*pq1(4)-q2(3)*pq1(3)-q2(2)*pq1(2)-q2(1)*pq1(1)
      pq1_pxc=pq1(4)*pxc(4)+pq1(3)*pxc(3)+pq1(2)*pxc(2)+pq1(1)*pxc(1)

      zout1=zout1/(-qsq2+2d0*q2_pq1)
      zout2=zout2/(mx**2-2d0*pq1_pxc)
      zout=zout1+zout2
      
cccccccccccccccccc

      zarr(1)=zout*eq(2)**2        ! u type, quark, gamma initial state
      zarr(2)=zout*eq(2)**2              ! u type, antiquark, gamma initial state
      zarr(3)=zout*eq(1)**2              ! d type, quark, gamma initial state
      zarr(4)=zout*eq(1)**2     ! d type, antiquark, gamma initial state
            
      zarr(5)=zout*(vq(2)-aq(2)*sign)*eq(2)  ! u type, quark, Z initial state
      zarr(6)=-zout*(vq(2)+aq(2)*sign)*eq(2)  ! u type, antiquark, Z initial state
      zarr(7)=zout*(vq(1)-aq(1)*sign)*eq(1)   ! d type, quark, Z initial state
      zarr(8)=-zout*(vq(1)+aq(1)*sign)*eq(1) ! d type, antiquark, Z initial state

      if(zfinal)then ! as above, but Z final state as well
         zarr(1)=zarr(1)+zout*(ve-ae*llsign(p))*(vq(2)-aq(2)*sign)*eq(2)
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(2)=zarr(2)-zout*(ve-ae*llsign(p))*(vq(2)+aq(2)*sign)*eq(2)
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(3)=zarr(3)+zout*(ve-ae*llsign(p))*(vq(1)-aq(1)*sign)*eq(1)
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(4)=zarr(4)-zout*(ve-ae*llsign(p))*(vq(1)+aq(1)*sign)*eq(1)
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(5)=zarr(5)+zout*(ve-ae*llsign(p))*(vq(2)-aq(2)*sign)**2
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(6)=zarr(6)+zout*(ve-ae*llsign(p))*(vq(2)+aq(2)*sign)**2
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(7)=zarr(7)+zout*(ve-ae*llsign(p))*(vq(1)-aq(1)*sign)**2
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
         zarr(8)=zarr(8)+zout*(ve-ae*llsign(p))*(vq(1)+aq(1)*sign)**2
     &        *mx**2/(mx**2-mz**2+zi*mz*gamz)*pzp
      endif
      
      return
      end

      function SF_g(diss,mu,mup,xb,x,xt,p1,q1,muf)
      complex*16 zt,zsum
      double precision xb,x,xt,muf,qsq1,mdiss
      double precision f1,f2,sf_g
      double precision p1(4),q1(4),q1t(4),p1t(4)
      integer mu,mup,i,i1,i2,iorder
      logical diss

      include 'gmatrices.f'
      include 'mom.f'
      include 'zi.f'
      include 'mp.f'
      include 'x.f'
      
      qsq1=q1(4)**2-q1(3)**2-q1(2)**2-q1(1)**2
      qsq1=-qsq1

      do i=1,2
         q1t(i)=q1(i)
      enddo
      q1t(4)=0d0
      q1t(3)=0d0

      do i=1,4
         p1t(i)=p1(i)
      enddo
      p1t(3)=-p1(3)
      
      mdiss=qsq1*(1d0-xb)/xb+mp**2
      mdiss=dsqrt(mdiss)
      call F1F2(diss,xb,qsq1,mdiss,f1,f2)

      
      SF_g = -(d_(mu,mup))*f1+(q1t(mu)+xt*p1t(mu))*
     &     (q1t(mup)+xt*p1t(mup))*2d0*xb*f2/qsq1/x**2

      SF_g=SF_g*2d0                 ! In def of rho
      
      return
      end

      function SF_Z(diss,mu,mup,xb,x,xt,p1,q1,muf)
      implicit none
      complex*16 zt,zsum,sf_z
      double precision xb,x,xt,muf,qsq1
      double precision f1gz,f1z,f2gz,f2z,f3gz,f3z
      double precision p1(4),q1(4),q1t(4),p1t(4)
      integer mu,mup,i,i1,i2,iorder,j
      logical diss

      include 'gmatrices.f'
      include 'mom.f'
      include 'zi.f'
      include 'mp.f'
      include 'x.f'
      
      qsq1=q1(4)**2-q1(3)**2-q1(2)**2-q1(1)**2
      qsq1=-qsq1

      do i=1,2
         q1t(i)=q1(i)
      enddo
      q1t(4)=0d0
      q1t(3)=0d0

      do i=1,4
         p1t(i)=p1(i)
      enddo
      p1t(3)=-p1(3)
      
      if(qsq1.lt.1d0.or.diss.eqv..false.)then
         sf_z=0d0
         return
      endif

      call FNC(xb,qsq1,f1gz,f1z,f2gz,f2z,f3gz,f3z)
      
      SF_z = -(d_(mu,mup))*f1z+(q1t(mu)+xt*p1t(mu))*
     &     (q1t(mup)+xt*p1t(mup))*2d0*xb*f2z/qsq1/x**2

      zsum=0d0
      do i=1,4 
         do j=1,4
            zt=-e_(mu,mup,i,j)*q1(i)*(q1t(j)+xt*p1t(j))/x
            if(i.lt.4)zt=-zt
            if(j.lt.4)zt=-zt
            zsum=zsum+zt
         enddo
      enddo

      sf_z=sf_z-zi*zsum*xb/qsq1*f3z

      sf_z=sf_z*2d0                 ! In def of rho
      
      return
      end

      function SF_Zg(diss,mu,mup,xb,x,xt,p1,q1,muf)
      implicit none
      complex*16 zt,zsum,sf_zg
      double precision xb,x,xt,muf,qsq1
      double precision f1gz,f1z,f2gz,f2z,f3gz,f3z
      double precision p1(4),q1(4),q1t(4),p1t(4)
      integer mu,mup,i,i1,i2,iorder,j
      logical diss

      include 'gmatrices.f'
      include 'mom.f'
      include 'zi.f'
      include 'mp.f'
      include 'x.f'
      
      qsq1=q1(4)**2-q1(3)**2-q1(2)**2-q1(1)**2
      qsq1=-qsq1

      do i=1,2
         q1t(i)=q1(i)
      enddo
      q1t(4)=0d0
      q1t(3)=0d0

      do i=1,4
         p1t(i)=p1(i)
      enddo
      p1t(3)=-p1(3)
      
      if(qsq1.lt.1d0.or.diss.eqv..false.)then
         sf_zg=0d0
         return
      endif
         
      call FNC(xb,qsq1,f1gz,f1z,f2gz,f2z,f3gz,f3z)
      
      SF_zg = -(d_(mu,mup))*f1gz+(q1t(mu)+xt*p1t(mu))*
     &     (q1t(mup)+xt*p1t(mup))*2d0*xb*f2gz/qsq1/x**2

      zsum=0d0
      do i=1,4
         do j=1,4
            zt=-e_(mu,mup,i,j)*q1(i)*(q1t(j)+xt*p1t(j))/x
            if(i.lt.4)zt=-zt
            if(j.lt.4)zt=-zt
            zsum=zsum+zt
         enddo
      enddo

      sf_zg=sf_zg-zi*zsum*xb/qsq1*f3gz

      sf_zg=sf_zg*2d0                 ! In def of rho
      
      return
      end
