      subroutine apfelinit
      implicit double precision(a-y)
      integer order,i
      
      include 'pdfinf.f'
      include 'ewsf.f'

      call initpdfsetm(2,'SF_MSHT20qed_nnlo')
c      call initpdfsetm(2,'SF_MMHT2015qed_nnlo')
      call initpdfm(2,0)

cccccccccccccc
      
      Sin2ThetaW=0.23126d0
      mz=91.1876d0
      gamz=2.4952d0

      ve = - 0.5d0 + 2d0 * Sin2ThetaW
      ae = - 0.5d0

      eq(1) = - 1d0 / 3d0
      eq(2) = 2d0 / 3d0
      eq(3) = eq(1) ! - 1d0 / 3d0
      eq(4) = eq(2) ! 2d0 / 3d0
      eq(5) = eq(1) ! - 1d0 / 3d0
      eq(6) = eq(2) ! 2d0 / 3d0
*
*     Squared Charges
*
      eq2(1) = eq(1) * eq(1)
      eq2(2) = eq(2) * eq(2)
      eq2(3) = eq2(1) ! eq(3) * eq(3)
      eq2(4) = eq2(2) ! eq(4) * eq(4)
      eq2(5) = eq2(1) ! eq(5) * eq(5)
      eq2(6) = eq2(2) ! eq(6) * eq(6)
      
      vq(1) = - 0.5d0 + 2d0 / 3d0 * Sin2ThetaW
      vq(2) = + 0.5d0 - 4d0 / 3d0 * Sin2ThetaW
      vq(3) = vq(1) ! - 0.5d0 + 2d0 / 3d0 * Sin2ThetaW
      vq(4) = vq(2) ! + 0.5d0 - 4d0 / 3d0 * Sin2ThetaW
      vq(5) = vq(1) ! - 0.5d0 + 2d0 / 3d0 * Sin2ThetaW
      vq(6) = vq(2) ! + 0.5d0 - 4d0 / 3d0 * Sin2ThetaW

      aq(1) = - 0.5d0
      aq(2) = + 0.5d0
      aq(3) = aq(1) ! - 0.5d0
      aq(4) = aq(2) ! + 0.5d0
      aq(5) = aq(1) ! - 0.5d0
      aq(6) = aq(2) ! + 0.5d0
      
      do i=1,6
         agam(i)=eq2(i) 
         azgam(i)=-2d0*eq(i)*vq(i)
         az(i)=vq(i)**2+aq(i)**2
         bzgam(i)=-2d0*eq(i)*aq(i)
         bz(i)=2d0*vq(i)*aq(i)
      enddo
      
      return
      end

