      subroutine qinit(x,qsq,i)
      implicit none
      double precision xit,rootq,q3,q0,mq
      double precision cq,bq,betaqt,aq,qsq,x
      double precision pq(4)
      integer i,j
      
      include 'mom.f'
      include 'leshouches.f'
      include 'mp.f'
      include 'diff.f'
      include 'pdg.f'
      include 'vars.f'

      mq=0.33d0

      q0=q(4,i+2)-q(4,i)
      q3=q(3,i+2)-q(3,i)

      aq=q0**2-q3**2
      bq=-2d0*q0*qsq/rts
      cq=4d0*mq**2*q3**2/s+qsq**2/s
      rootq=bq**2-4d0*aq*cq

      xit=-bq-dsqrt(rootq)
      xit=xit/2d0/aq

      betaqt=dsqrt(1d0-4d0*mq**2/s/xit**2)
      pq(4)=xit*rts/2d0
      if(i.eq.1)pq(3)=pq(4)*betaqt
      if(i.eq.2)pq(3)=-pq(4)*betaqt

      do j=1,4
        q(j,10+i)=pq(j)
        q(j,10+i+2)=pq(j)-q(j,i)+q(j,i+2)
      enddo

      pdgid(6+i)=2
      pdgid(6+i+2)=2
      istup(6+i)=-1
      istup(6+i+2)=1
      icolup(1,6+i)=500+i
      icolup(1,6+i+2)=500+i
      mothup(1,6+i+2)=1
      mothup(2,6+i+2)=2
      
      return
      end
