      function cs(rarr,wgt)
      implicit none
      double precision runw,ran2,rdiss,cs,ry,rm,rdiss1,rdiss2,rdisst
      double precision r1,r2,r3,r4,rtheta
      double precision ypp,yp,ypmin1,ypmin2,ypmax1,ypmax2
      double precision ymin0,ymax0,xgmin,mxx,msub,mmax0
      double precision mdissmax,lmdissmax,lmdissmin,lmdiss1,lmdiss2
      double precision wty1,wty2,wty,wtt,wtt0,wtdiss1,wtdiss2,wtmx,wt0
      double precision val,root1sq,root2sq,rmx,renpdf
      double precision ptxx,ptmin,ptmax1,ptmax2,ptmax
      double precision pt1x,pt1y,pt2x,pt2y,pt1sq,pt2sq
      double precision ps,phi1,phi2,p1p,p2m,p1m,p2p
      double precision mpp1,mpp2,cc1,cc2,aa1,aa2
      double precision out,wgt,wtsubt,pssubt
      complex*16 wt(20),zout,zout1,zout2
      double precision rarr(30)
      integer i,p,icut,npart

      include 'gencuts.f'
      include 'pi.f'
      include 'unweighted.f'
      include 'bin.f'
      include 'x.f'
      include 'zi.f'
      include 'vars.f'
      include 'mom.f'
      include 'range.f'
      include 'polarization.f'
      include 'proc.f'
      include 'mq.f'
      include 'mp.f'
      include 'eff.f'
      include 'wmax.f'
      include 'xb.f'
      include 'diss.f'
      include 'diff.f'
      include 'pdg.f'
      include 'NSF.f'
      include 'mres.f'
      include 'llscat.f'
      include 'wtarr.f'
      include 'pdfinf.f'
      include 'kmu.f'
      include 'qsq.f'


      
      if(SFerror)then
         npdf=62
         if(coll.neqv..true.)npdf=60
         if(SCerror)npdf=2
      else
         npdf=0
      endif

      do i=0,npdf
         wtarr(i)=0d0
      enddo
      
      wtt=0d0
      
cccccccccccccccc
      
      if(coll.neqv..true.)goto 900

      if(proc.eq.4)then
         print*,"Lepton-lepton scattering not implemented"//
     &        " in collinear mode: stop!"
         stop
      endif
       
cccc  M_X (central system) integration
       
      if(mmax.gt.rts)mmax=rts
      if(mmin.lt.2d0*mq)mmin=2d0*mq
      rm=rarr(2)

      
      msub=1d0/1d0*(1d0/mmax**1d0+
     &     (1d0/mmin**1d0-1d0/mmax**1d0)*rm)
      mx=(1d0/msub/1d0)**(1d0/1d0)

      mxx=mx

      wtmx=mxx**2*(1d0/mmin**1d0-1d0/mmax**1d0)/1d0 ! Jacobian

      ry=rarr(1)
      
      yx=ymin+(ymax-ymin)*ry
      wty=ymax-ymin

      x1=mxx*dexp(yx)/rts       ! photon 1 mom. fraction 
      x2=mxx*dexp(-yx)/rts      ! photon 2 mom. fraction 

      if(x1.gt.1d0)goto 777
      if(x2.gt.1d0)goto 777
      
      do i=1,2
         q(i,5)=0d0
      enddo
      q(4,5)=(x1+x2)*rts/2d0
      q(3,5)=(x1-x2)*rts/2d0
      
      rtheta=rarr(3)
      call twojetps(5,mx,mq,rtheta,ps)
      ps=ps*(2d0*pi)**4 ! delta^(4)() explicit in collinear case
      
ccccccccccccccc      
       
      neff0=neff0+1
      
      if(gencuts)then
         call cut(icut)
         if(icut.eq.0)goto 777
      endif
      
      neff=neff+1
      
cccccccccccccc

      
      do p=1,pol
         
         if(proc.lt.4)then
            if(subt)then
               call ll_subt(p)
            else
               call ll_coll(p)
            endif
         endif

         
         do ipdf=0,npdf

            if(SCerror)then
               if(ipdf.eq.0)kmu=1d0
               if(ipdf.eq.1)kmu=2d0
               if(ipdf.eq.2)kmu=0.5d0
            elseif(SFerror)then
               call initpdfm(1,ipdf)
            endif   
            if(subt)then
               call cs_subt(p,out)
            else
               call cs_coll(p,out)
            endif
            
            wtarr(ipdf)=wtarr(ipdf)+out
            
         enddo
         
      enddo
      
      wtt=wtarr(0)
      
      wtt=wtt*wty               ! Rapidity
      wtt=wtt*wtmx

      wtt=wtt*2d0*mxx/s ! dx_1 dx_2 -> dM_X dY_X

      wtt=wtt/2d0/mxx**2    ! Flux
      wtt=wtt*ps          
      
      goto 888
      
ccccccccccccccccc

cccc  M_X (central system) integration

 900  continue

      if(dps.eq.2)then
         
         if(mmax.gt.rts)mmax=rts
         if(mmin.lt.2d0*mq)mmin=2d0*mq
         rm=rarr(5)
         
         if(proc.eq.4)then
            mmax0=mmax
            mmax=rts
         endif
         
         msub=1d0/1d0*(1d0/mmax**1d0+
     &        (1d0/mmin**1d0-1d0/mmax**1d0)*rm)
         mx=(1d0/msub/1d0)**(1d0/1d0)

         mxx=mx
         
         wtmx=mxx**2*(1d0/mmin**1d0-1d0/mmax**1d0)/1d0 ! Jacobian

         if(proc.eq.4)then
            mmax=mmax0
         endif

      elseif(dps.eq.1)then

         mx=mres
         mxx=mx
         wtmx=1d0/2d0/mx
         
      endif
      
      r1=ran2()
      ry=rarr(1)
      r2=rarr(2)
      r3=rarr(3)
      r4=rarr(4)
      
cccccccc
      
      mpp1=mp  ! set beam masses
      mpp2=mp

ccccccccccccc
      
      if(difftot)then   ! Mix between single/double diss. + elastic
         rdisst=rarr(9)
         if(rdisst.lt.1d0/3d0)then
            diff='el'
            diss1=.false.
            diss2=.false.
            if(noSF)goto 777               
         elseif(rdisst.lt.2d0/3d0)then
            diff='sd'
         else
            diff='dd'
            diss1=.true.
            diss2=.true.
         endif
      endif

      if(diff.eq.'sd')then
         rdiss=ran2()
         if(rdiss.gt.0.5d0)then
            diss1=.true.
            diss2=.false.
         else
            diss1=.false.
            diss2=.true.
         endif
         if(diffsd.eq.'sda')then
            diss1=.true.
            diss2=.false.
         elseif(diffsd.eq.'sdb')then
            diss1=.false.
            diss2=.true.
         endif
      endif

      
ccccccccccccc      
      
      phi1=2d0*pi*r1
      phi2=2d0*pi*r2+phi1
      
      ptmax=dsqrt(3d0)  ! max p_t for elastic
      ptmin=0d0
      
      xgmin=(mxx/rts)**2
      
      if(diss1)then ! if beam 1 dissociates
         ptmax1=1d4
         ypmax1=dlog(xgmin**2*mpp1**2+ptmax1**2)
         ypmin1=dlog(xgmin**2*mpp1**2)
         yp=(ypmax1-ypmin1)*r3+ypmin1
         pt1sq=dexp(yp)-xgmin**2*mpp1**2
         wty1=(ypmax1-ypmin1)*(xgmin**2*mpp1**2+pt1sq)
      else
         ypmax1=dlog(xgmin**2*mpp1**2+ptmax**2)
         ypmin1=dlog(xgmin**2*mpp1**2)
         yp=(ypmax1-ypmin1)*r3+ypmin1
         pt1sq=dexp(yp)-xgmin**2*mpp1**2
         wty1=(ypmax1-ypmin1)*(xgmin**2*mpp1**2+pt1sq)
      endif
      
      if(diss2)then ! if beam 2 dissociates
         ptmax2=1d4
         ypmax2=dlog(xgmin**2*mpp2**2+ptmax2**2)
         ypmin2=dlog(xgmin**2*mpp2**2)
         ypp=(ypmax2-ypmin2)*r4+ypmin2         
         pt2sq=dexp(ypp)-xgmin**2*mpp2**2
         wty2=(ypmax2-ypmin2)*(xgmin**2*mpp2**2+pt2sq)
      else
         ypmax2=dlog(xgmin**2*mpp2**2+ptmax**2)
         ypmin2=dlog(xgmin**2*mpp2**2)
         ypp=(ypmax2-ypmin2)*r4+ypmin2         
         pt2sq=dexp(ypp)-xgmin**2*mpp2**2
         wty2=(ypmax2-ypmin2)*(xgmin**2*mpp2**2+pt2sq)
      endif

ccccc 
      
      if(pt1sq.lt.0d0)then
         pt1sq=0d0
      endif
      
      if(pt2sq.lt.0d0)then
         pt2sq=0d0
      endif

cccccccc  Assign proton/beam remnant p_t vectors      
      
      pt2x=dsqrt(pt2sq)*dcos(phi2)
      pt2y=dsqrt(pt2sq)*dsin(phi2)
      pt1x=dsqrt(pt1sq)*dcos(phi1)
      pt1y=dsqrt(pt1sq)*dsin(phi1)

cccccccc Central system 4-momentum
      
      ptxx=(pt1x+pt2x)**2+(pt1y+pt2y)**2

      rmx=dsqrt(ptxx+mxx**2)

      if(proc.eq.4)then
         ymin0=ymin
         ymax0=ymax
         ymax=dlog(rts/rmx)
         ymin=-ymax
      endif
      
      yx=ymin+(ymax-ymin)*ry
      wty=ymax-ymin

      if(proc.eq.4)then
         ymin=ymin0
         ymax=ymax0
      endif

      x1=rmx*dexp(yx)/rts       ! photon 1 mom. fraction 
      x2=rmx*dexp(-yx)/rts      ! photon 2 mom. fraction
 
      if(x1.gt.1d0)goto 777
      if(x2.gt.1d0)goto 777


cccccccc   Integrate over proton dissociation mass (if inelastic)
      
      mdissmax=rts/2d0
      
      lmdissmax=dlog(mdissmax)
      lmdissmin=dlog(mp)
      
      if(diss1)then
         rdiss1=rarr(7)
         lmdiss1=lmdissmin+(lmdissmax-lmdissmin)*rdiss1
         mdiss1=dexp(lmdiss1)
         wtdiss1=2d0*mdiss1**2*(lmdissmax-lmdissmin)
      else
         mdiss1=mp
         wtdiss1=1d0
      endif

      if(diss2)then
         rdiss2=rarr(8)
         if(diff.eq.'sd')rdiss2=rarr(7)
         lmdiss2=lmdissmin+(lmdissmax-lmdissmin)*rdiss2
         mdiss2=dexp(lmdiss2)
         wtdiss2=2d0*mdiss2**2*(lmdissmax-lmdissmin)
      else
         mdiss2=mp
         wtdiss2=1d0
      endif
  
      mpp1=mdiss1
      mpp2=mdiss2
      
ccccccccccccccccccc Generate proton/dissociation E and p_z by imposing mass-shell conditions
      
      aa1=(1d0-x1)*rts/dsqrt(2d0)
      aa2=(1d0-x2)*rts/dsqrt(2d0)
      cc1=0.5d0*(pt2sq+mpp2**2)
      cc2=0.5d0*(pt1sq+mpp1**2)

c     impose massive on-shell condition by solving
c                   p1+ + cc1/p2- = aa1
c                   p2- + cc2/p1+ = aa2 

      root1sq=(cc1-cc2-aa1*aa2)**2-4d0*cc2*aa1*aa2
      root2sq=(cc2-cc1-aa1*aa2)**2-4d0*cc1*aa1*aa2
      
      if(root1sq.le.0d0.or.root2sq.le.0d0)goto 777
      
      p1p=(cc2-cc1+aa1*aa2+dsqrt(root1sq))/(2d0*aa2)
      p2m=(cc1-cc2+aa1*aa2+dsqrt(root2sq))/(2d0*aa1)
      p1m=(pt1sq+mpp1**2)/(2d0*p1p)
      p2p=(pt2sq+mpp2**2)/(2d0*p2m)

      if(p1m.lt.0d0)goto 777
      if(p2p.lt.0d0)goto 777

      q(1,3)=pt1x
      q(2,3)=pt1y
      q(3,3)=(p1p-p1m)/dsqrt(2d0)
      q(4,3)=(p1p+p1m)/dsqrt(2d0)

      q(1,4)=pt2x
      q(2,4)=pt2y
      q(3,4)=(p2p-p2m)/dsqrt(2d0)
      q(4,4)=(p2p+p2m)/dsqrt(2d0)

      do i=1,4
         q(i,5)=q(i,1)+q(i,2)-q(i,3)-q(i,4)
      enddo

ccccccccccccc

      qsq1=(q(4,3)-q(4,1))**2-(q(3,3)-q(3,1))**2-(q(2,3)-q(2,1))**2
     &     -(q(1,3)-q(1,1))**2
      qsq1=-qsq1
     
      qsq2=(q(4,4)-q(4,2))**2-(q(3,4)-q(3,2))**2-(q(2,4)-q(2,2))**2
     &     -(q(1,4)-q(1,2))**2
      qsq2=-qsq2

      do i=1,4
         q1(i)=q(i,1)-q(i,3)
         q2(i)=q(i,2)-q(i,4)
      enddo

ccccccc
      
      if(diss1)then  ! Bjorken x
         xb1=qsq1/(qsq1+mdiss1**2-mp**2)
      else
         xb1=1d0
      endif
      if(diss2)then
         xb2=qsq2/(qsq2+mdiss2**2-mp**2)
      else
         xb2=1d0
      endif
      
      if(diss1.and.xb1.gt.1d0)goto 777
      if(diss2.and.xb2.gt.1d0)goto 777
      
      if(diss1)wtdiss1=wtdiss1/qsq1
      if(diss2)wtdiss2=wtdiss2/qsq2

      if(diss1)call qinit(xb1,qsq1,1)
      if(diss2)call qinit(xb2,qsq2,2)
  
ccccccccccccccccccccccccccccccccc
      
      if(dps.eq.2)then
         if(proc.eq.4)then
            call phase4(rarr,wt0)
         else
            call twojetps(5,mx,mq,rarr(6),ps)
            wt0=ps
         endif
         if(wt0.lt.0d0)goto 777
      elseif(dps.eq.1)then
         wt0=1d0
      endif
      

     
ccccccccccccccccccc  cuts ccccccccccccccccc

         neff0=neff0+1

         if(gencuts)then
            call cut(icut)
            if(icut.eq.0)goto 777
         endif

         neff=neff+1

c$$$ccccccccc

         call wtgengam ! gam gam -> X amplitudes
         
         do ipdf=0,npdf

            if(SCerror)then
               if(ipdf.eq.0)kmu=1d0
               if(ipdf.eq.1)kmu=2d0
               if(ipdf.eq.2)kmu=0.5d0
            endif
               
            wtt=0d0
   
         do p=1,pol             ! multiply by structure functions
            call SFcalc(p,out)
            wt(p)=out
            wtarr(ipdf)=wtarr(ipdf)+cdabs(wt(p))
         enddo
         
      enddo

      wtt=wtarr(0)
      
cccccccc
      
      wtt=wtt*wty1*wty2

      wtt=wtt*s/2d0/dabs(p1p*p2m-p1m*p2p) ! Jacobian factor (hardly matters in high energy)

      if(proc.eq.4)then
         if(lep1.ne.lep2)wtt=wtt*2d0 ! leptons from either side
         if(lep1.eq.lep2)wtt=wtt/2d0 ! symmetry factor identical leptons
         wtt=wtt*2d0            ! Only explicitly calculate 8 of 16 lepton helicities (other 8 identical)
      endif
         
      wtt=wtt*wt0
      
      wtt=wtt*pi**2             ! photon phi integral
      wtt=wtt/2d0/s             ! Flux factor
      wtt=wtt*2d0*mxx/s         ! dx_1 dx_2 -> dM_X dY_X
      
      wtt=wtt*wty               ! Rapidity
      wtt=wtt*wtmx
      
      wtt=wtt*wtdiss1*wtdiss2   !
      
      if(diff.eq.'sd')wtt=wtt*2d0
      if(diffsd.eq.'sda'.or.diffsd.eq.'sdb')wtt=wtt/2d0
      if(difftot)wtt=wtt*3d0
      
 888  val=wtt*wgt

         if(SFerror)then
            if(wtt.eq.0d0)then
               renpdf=0d0
            else
               renpdf=wtt/wtarr(0)
            endif
            do i=0,npdf
               wtarr(i)=wtarr(i)*renpdf*wgt
               sumarr(i)=sumarr(i)+wtarr(i)
            enddo
         endif
         
         if(bin)then
         call binit(val)
         endif

ccccccccc Set elastic photon on-shell *only* in event record for SD, to work with pythia
         
         if(diff.eq.'sd'.and.unw.eqv..true.)then  

            if(diss1)then
            else
               pt1sq=0d0
               pt1x=0d0
               pt1y=0d0
            endif

            if(diss2)then
            else
               pt2sq=0d0
               pt2x=0d0
               pt2y=0d0
            endif

            ptxx=(pt1x+pt2x)**2+(pt1y+pt2y)**2
            rmx=dsqrt(mx**2+ptxx)
            
            x1=rmx/rts*dexp(yx)
            x2=rmx/rts*dexp(-yx)
            
            if(x1.gt.1d0)goto 777
            if(x2.gt.1d0)goto 777

ccccccccccccccc            
            
            aa1=(1d0-x1)*rts/dsqrt(2d0)
            aa2=(1d0-x2)*rts/dsqrt(2d0)
            cc1=0.5d0*(pt2sq+mpp2**2)
            cc2=0.5d0*(pt1sq+mpp1**2)
            
c     impose massive on-shell condition by solving
c     p1+ + cc1/p2- = aa1
c                   p2- + cc2/p1+ = aa2 
            
            root1sq=(cc1-cc2-aa1*aa2)**2-4d0*cc2*aa1*aa2
            root2sq=(cc2-cc1-aa1*aa2)**2-4d0*cc1*aa1*aa2
            
            if(root1sq.le.0d0.or.root2sq.le.0d0)goto 777
            
            p1p=(cc2-cc1+aa1*aa2+dsqrt(root1sq))/(2d0*aa2)
            p2m=(cc1-cc2+aa1*aa2+dsqrt(root2sq))/(2d0*aa1)
            p1m=(pt1sq+mpp1**2)/(2d0*p1p)
            p2p=(pt2sq+mpp2**2)/(2d0*p2m)
            
            if(p1m.lt.0d0)goto 777
            if(p2p.lt.0d0)goto 777
      
            q(1,3)=pt1x
            q(2,3)=pt1y
            q(3,3)=(p1p-p1m)/dsqrt(2d0)
            q(4,3)=(p1p+p1m)/dsqrt(2d0)
            
            q(1,4)=pt2x
            q(2,4)=pt2y
            q(3,4)=(p2p-p2m)/dsqrt(2d0)
            q(4,4)=(p2p+p2m)/dsqrt(2d0)
            
            do i=1,4
               q(i,5)=q(i,1)+q(i,2)-q(i,3)-q(i,4)
            enddo
            
            if(proc.eq.4)then
               call phase4(rarr,wt0)
            else
               call twojetps(5,mx,mq,rarr(6),ps)
               wt0=1d0
         endif
            
         endif

         if(diss1)call qinit(xb1,qsq1,1)
         if(diss2)call qinit(xb2,qsq2,2)
         
   
         if(wmax.lt.wtt*wgt*ren)then
            wmax=wtt*wgt*ren
            iw=iw+1
         endif

         if(unw)then
            runw=ran2()
            call unweightq(wtt*wgt*ren,runw)
         endif

 777     cs=wtt

      return
      end

   
