      subroutine llscatt(p)
      implicit none
      complex*16 zt,zt1,zt2,zout
      double precision alphaEM,tsq
      double precision qt1(4),qt2(4)
      double precision plp1(4),plm1(4),plp2(4),plm2(4)
      double precision qt1sw(4),qt2sw(4)
      double precision plp1sw(4),plm1sw(4),plp2sw(4),plm2sw(4)
      complex*16 zasc1(2,2,4,4),zasc2(2,2,4,4)
      complex*16 zasc1sw(2,2,4,4),zasc2sw(2,2,4,4)
      integer i1,i2
      integer i,j,k,l,p,m,n
      integer hp1,hm1,hp2,hm2,hp0,hm0
      common/zasc/zasc1,zasc2,zasc1sw,zasc2sw
      common/pl/qt1,qt2
      common/plsw/qt1sw,qt2sw
      
      include 'mom.f'
      include 'gmatrices.f'
      include 'gmatrices_comb.f'
      include 'ewpars.f'
      include 'pi.f'
      include 'vars.f'
      include 'partonmom2.f'
      include 'norm.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'diss.f'
      include 'x.f'
      include 'llscat.f'
      include 'qsq.f'

      if(p.eq.1)then
      
      do i=1,4

         if(lep1.eq.'e-'.or.lep1.eq.'mu-'.or.lep1.eq.'tau-')then
            plm1(i)=q(i,6)
            plp1(i)=q(i,8)
         else
            plm1(i)=q(i,8)
            plp1(i)=q(i,6)
         endif

         if(lep2.eq.'e-'.or.lep2.eq.'mu-'.or.lep2.eq.'tau-')then
            plm2(i)=q(i,7)
            plp2(i)=q(i,9)
         else
            plm2(i)=q(i,9)
            plp2(i)=q(i,7)
         endif

         qt1(i)=plm1(i)+plp1(i)-q1(i)
         qt2(i)=plm2(i)+plp2(i)-q2(i)

      enddo

      endif
      
      if(p.le.8)then
         hp1=1
      else
         hp1=2
      endif

      if(p.eq.5.or.p.eq.13)then
         hm1=1
         hp2=1
         hm2=1
      elseif(p.eq.1.or.p.eq.9)then
         hm1=1
         hp2=2
         hm2=1         
      elseif(p.eq.2.or.p.eq.10)then
         hm1=1
         hp2=1
         hm2=2         
      elseif(p.eq.6.or.p.eq.14)then
         hm1=1
         hp2=2
         hm2=2         
      elseif(p.eq.7.or.p.eq.15)then
         hm1=2
         hp2=1
         hm2=1
      elseif(p.eq.3.or.p.eq.11)then
         hm1=2
         hp2=2
         hm2=1
      elseif(p.eq.4.or.p.eq.12)then
         hm1=2
         hp2=1
         hm2=2
      elseif(p.eq.8.or.p.eq.16)then
         hm1=2
         hp2=2
         hm2=2
      endif
      
      if(p.eq.1)then
         do i1=1,2
            do i2=1,2
               do i=1,4
                  do j=1,4
                     call vertex_scat(i,j,i1,i2,q1,qt1,plp1,plm1,zt1)
                     call vertex_scat(i,j,i1,i2,q2,qt2,plp2,plm2,zt2)
                     zasc1(i1,i2,i,j)=zt1
                     zasc2(i1,i2,i,j)=zt2
                  enddo
               enddo
            enddo
         enddo
      endif

      tsq=qt1(4)**2-qt1(3)**2-qt1(2)**2-qt1(1)**2

      do i=1,4
         do j=1,4
            zout=0d0
            do k=1,4
               zt=zasc1(hp1,hm1,i,k)*zasc2(hp2,hm2,j,k)
     &              /tsq*alphaEM(-tsq)
               zt=zt*4d0*pi
               zt=zt*4d0*pi*dsqrt(alphaEM(qsq1)*alphaEM(qsq2))
               zt=zt*dsqrt(conv)
               if(k.lt.4)zt=-zt
               zout=zout+zt
            enddo
            zoutarr(p,i,j)=zout
         enddo
      enddo
      
      if(lep1.ne.lep2)return
      
ccccccccccIdentical particle swap

      if(p.eq.1)then
      
      do i=1,4
         
         if(lep1.eq.'e-'.or.lep1.eq.'mu-'.or.lep1.eq.'tau-')then
            plm1sw(i)=q(i,7)
            plp1sw(i)=q(i,8)
         else
            plm1sw(i)=q(i,8)
            plp1sw(i)=q(i,7)
         endif

         if(lep2.eq.'e-'.or.lep2.eq.'mu-'.or.lep2.eq.'tau-')then
            plm2sw(i)=q(i,6)
            plp2sw(i)=q(i,9)
         else
            plm2sw(i)=q(i,9)
            plp2sw(i)=q(i,6)
         endif

         qt1sw(i)=plm1sw(i)+plp1sw(i)-q1(i)
         qt2sw(i)=plm2sw(i)+plp2sw(i)-q2(i)
         
      enddo

      endif

      if(p.le.8)then
         hp1=1
      else
         hp1=2
      endif

      if(p.eq.5.or.p.eq.13)then
         hm1=1
         hp2=1
         hm2=1
      elseif(p.eq.1.or.p.eq.9)then
         hm1=1
         hp2=2
         hm2=1         
      elseif(p.eq.2.or.p.eq.10)then
         hm1=1
         hp2=1
         hm2=2         
      elseif(p.eq.6.or.p.eq.14)then
         hm1=1
         hp2=2
         hm2=2         
      elseif(p.eq.7.or.p.eq.15)then
         hm1=2
         hp2=1
         hm2=1
      elseif(p.eq.3.or.p.eq.11)then
         hm1=2
         hp2=2
         hm2=1
      elseif(p.eq.4.or.p.eq.12)then
         hm1=2
         hp2=1
         hm2=2
      elseif(p.eq.8.or.p.eq.16)then
         hm1=2
         hp2=2
         hm2=2
      endif
      
      if(lep1.eq.'e-'.or.lep1.eq.'mu-'.or.lep1.eq.'tau-')then
         hm0=hm1
         hm1=hm2
         hm2=hm0
      else
         hp0=hp1
         hp1=hp2
         hp2=hp0
      endif

      if(p.eq.1)then
         do i1=1,2
            do i2=1,2
               do i=1,4
                  do j=1,4
                     call vertex_scat(i,j,i1,i2,q1,qt1sw,plp1sw
     &                    ,plm1sw,zt1)
                     call vertex_scat(i,j,i1,i2,q2,qt2sw,plp2sw
     &                    ,plm2sw,zt2)
                     zasc1sw(i1,i2,i,j)=zt1
                     zasc2sw(i1,i2,i,j)=zt2
                  enddo
               enddo
            enddo
         enddo
      endif

      tsq=qt1sw(4)**2-qt1sw(3)**2-qt1sw(2)**2-qt1sw(1)**2

      do i=1,4
         do j=1,4
            zout=0d0
            do k=1,4
               zt=zasc1sw(hp1,hm1,i,k)*zasc2sw(hp2,hm2,j,k)
     &              /tsq*alphaEM(-tsq)
               zt=zt*4d0*pi
               zt=zt*4d0*pi*dsqrt(alphaEM(qsq1)*alphaEM(qsq2))
               zt=zt*dsqrt(conv)
               if(k.lt.4)zt=-zt
               zout=zout+zt
            enddo
            zoutarr(p,i,j)=zoutarr(p,i,j)-zout
         enddo
      enddo
      
      
      return
      end


      subroutine vertex_scat(mu,sig,h1,h2,q1,qt,plp,plm,zout)
      implicit none
      complex*16 zt1,zt2,zoutm1,zoutm2,zout1,zout2
      double precision qsq,mq,den1,den2
      double precision q1(4),qt(4),plp(4),plm(4)
      complex*16 u(4),ub(4)
      integer h1,h2,i,j,i1,i2,mu,sig
      complex*16 zout
         
      include 'gmatrices.f'
      include 'gmatrices_comb.f'
      include 'mom.f'
      include 'zi.f'
      include 'zoutarr.f'
      
      do i=1,4
         q(i,16)=plp(i)
         q(i,17)=plm(i)
      enddo
      
      qsq=q1(4)**2-q1(3)**2-q1(2)**2-q1(1)**2
      qsq=-qsq

      mq=dsqrt(dabs(plp(4)**2-plp(3)**2-plp(2)**2-plp(1)**2))
      
      if(h1.eq.1.and.h2.eq.1)then
         call vp(16,u)
         call upb(17,ub)
      elseif(h1.eq.1.and.h2.eq.2)then
         call vp(16,u)
         call umb(17,ub)
      elseif(h1.eq.2.and.h2.eq.1)then
         call vm(16,u)
         call upb(17,ub)
      else
         call vm(16,u)
         call umb(17,ub)
      endif

      zout1=0d0
      zout2=0d0
      
      do i1=1,4
         do i2=1,4
            do j=1,4
               zt1=ub(i1)*gmatrix_3(sig,j,mu,i1,i2)*u(i2)*
     &              (q1(j)-plp(j))
               zt2=ub(i1)*gmatrix_3(mu,j,sig,i1,i2)*u(i2)*
     &              (plm(j)-q1(j))
               if(j.lt.4)zt1=-zt1
               if(j.lt.4)zt2=-zt2
               zout1=zout1+zt1
               zout2=zout2+zt2
            enddo
         enddo
      enddo

      zoutm1=0d0
      zoutm2=0d0
      
      do i1=1,4
         do i2=1,4
               zt1=ub(i1)*gmatrix_2(sig,mu,i1,i2)*u(i2)*mq
               zt2=ub(i1)*gmatrix_2(mu,sig,i1,i2)*u(i2)*mq
               zoutm1=zoutm1+zt1
               zoutm2=zoutm2+zt2
         enddo
      enddo

      zout1=zout1+zoutm1
      zout2=zout2+zoutm2


      den2=-qsq-2d0*(plm(4)*q1(4)-plm(3)*q1(3)-plm(2)*q1(2)
     &     -plm(1)*q1(1))

      den1=-qsq-2d0*(plp(4)*q1(4)-plp(3)*q1(3)-plp(2)*q1(2)
     &     -plp(1)*q1(1))

      zout1=zout1/den1
      zout2=zout2/den2

      zout=zout1+zout2
         
      return
      end
