      subroutine cut(icut)
      implicit double precision(a-y)
      double precision p1(4),p2(4),p3(4),mxx,yxx
      double precision pj1(4),pj2(4),pl1(4),pl2(4)
      double precision xi1,xi2,pq1(4),pq2(4)
      double precision ptj1,ptj2,pmodj1,pmodj2,etaj1,etaj2
      integer icut,jflag,i,j
      logical accut

      include 'gencuts.f'
      include 'vars.f'
      include 'mom.f'
      include 'proc.f'
      include 'decay.f'
      include 'pi.f'
      include 'ptXcuts.f'
      include 'range.f'
      include 'qsq.f'

      icut=0
      
ccccccccccccccccccccccccccccccccccccccccccccc
ccc
cc    Place user-defined cuts here if needed
cc
cc    if(..)return - return for failed cut
cc
cccccccccccccccccccccccccccccccccccccccccccccc

      ptll=dsqrt((q(1,6)+q(1,7))**2+(q(2,6)+q(2,7))**2)

      if(ptll.lt.ptllmin)return
         
      pmod6=dsqrt(q(1,6)**2+q(2,6)**2+q(3,6)**2)
      pmod7=dsqrt(q(1,7)**2+q(2,7)**2+q(3,7)**2)
      eta6=0.5d0*dlog((pmod6+q(3,6))/(pmod6-q(3,6)))
      eta7=0.5d0*dlog((pmod7+q(3,7))/(pmod7-q(3,7)))
      y6=0.5d0*dlog((q(4,6)+q(3,6))/(q(4,6)-q(3,6)))
      y7=0.5d0*dlog((q(4,7)+q(3,7))/(q(4,7)-q(3,7)))
      pt6=dsqrt(q(1,6)**2+q(2,6)**2)
      pt7=dsqrt(q(1,7)**2+q(2,7)**2)

      if(proc.eq.4)then

      if(pt6.gt.pt7)then
         ptmax=pt6
      else
         ptmax=pt7
      endif

      b2b=dsqrt((q(1,6)+q(1,7))**2+(q(2,6)+q(2,7))**2)
      b2b=b2b/ptmax
      
c      if(b2b.gt.0.1d0)return
      
      delphi=(q(1,6)*q(1,7)+q(2,6)*q(2,7))
     &     /dsqrt((q(1,6)**2+q(2,6)**2))
     &     /dsqrt((q(1,7)**2+q(2,7)**2))
      if(dabs(delphi).gt.1d0)delphi=delphi/dabs(delphi)
      delphi=dacos(delphi)

c      if(dabs(delphi-pi).gt.0.1d0)return

      mxx=dsqrt((q(4,6)+q(4,7))**2-(q(3,6)+q(3,7))**2-(q(2,6)+q(2,7))**2
     &     -(q(1,6)+q(1,7))**2)

      yxx=0.5d0*dlog((q(4,6)+q(4,7)+q(3,6)+q(3,7))
     &     /(q(4,6)+q(4,7)-q(3,6)-q(3,7)))

      if(yxx.gt.ymax)return
      if(yxx.lt.ymin)return

      if(mxx.lt.mmin)return
      if(mxx.gt.mmax)return
       
      endif

      if(pt6.lt.ptamin)return
      if(pt7.lt.ptbmin)return
      if(eta6.lt.etaamin)return
      if(eta7.lt.etabmin)return
      if(eta6.gt.etaamax)return
      if(eta7.gt.etabmax)return
      
      icut=1

      return
      end
 
